=== modified file 'bzrlib/tests/__init__.py'
--- bzrlib/tests/__init__.py	2011-07-27 05:05:15 +0000
+++ bzrlib/tests/__init__.py	2011-08-09 09:11:17 +0000
@@ -386,9 +386,18 @@
         getDetails = getattr(test, "getDetails", None)
         if getDetails is not None:
             getDetails().clear()
+        # Clear _type_equality_funcs to try to stop TestCase instances
+        # from wasting memory. 'clear' is not available in all Python
+        # versions (bug 809048)
         type_equality_funcs = getattr(test, "_type_equality_funcs", None)
         if type_equality_funcs is not None:
-            type_equality_funcs.clear()
+            tef_clear = getattr(type_equality_funcs, "clear", None)
+            if tef_clear is None:
+                tef_instance_dict = getattr(type_equality_funcs, "__dict__", None)
+                if tef_instance_dict is not None:
+                    tef_clear = tef_instance_dict.clear
+            if tef_clear is not None:
+                tef_clear()
         self._traceback_from_test = None
 
     def startTests(self):

=== modified file 'doc/en/release-notes/bzr-2.4.txt'
--- doc/en/release-notes/bzr-2.4.txt	2011-07-27 13:17:45 +0000
+++ doc/en/release-notes/bzr-2.4.txt	2011-08-09 09:11:17 +0000
@@ -63,6 +63,10 @@
   avoiding an extra SSH connection, etc.
   (John Arbash Meinel, #812285)
 
+* Cope with not all Python versions having a ``clear`` method on
+  ``TestCase._type_equality_funcs``. (#809048, Martin [gz], Jelmer
+  Vernooij)
+
 Documentation
 *************
 

